// Test.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "Test.h"
#include "tdxface.h"
#include "TestTDXDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CTestApp

BEGIN_MESSAGE_MAP(CTestApp, CWinApp)
	//{{AFX_MSG_MAP(CTestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestApp construction

CTestApp::CTestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTestApp object

CTestApp theApp;




DWORD 
APIENTRY 
OnPropertiesComponent(
	LONG lConfigID,					// id of the active config
	LPCWSTR szCapabilityName,		// address of name of selected capability
	LPCWSTR szComponentName,		// address of name of selected component
	UINT nAppNum,					// index of the activated tdx
	LPCWSTR szHelpFilePath			// pointer to the full path name of the help file
	)
/*++
Function Description:
	Runs a custom tdx applet
Return code:
	TDX_SUCCESS - the applet was run successfully
	TDX_FAILED - the applet was not run successfully and did not notify the use
	TDX_FAILED_NONOTIFY - the applet was not run successfully and did notify the use
--*/
{
    UNREFERENCED_PARAMETER(szCapabilityName);
    UNREFERENCED_PARAMETER(szComponentName);
    UNREFERENCED_PARAMETER(nAppNum);
	UNREFERENCED_PARAMETER(szHelpFilePath);

	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    CTestTDXDialog dlg(lConfigID, AfxGetMainWnd());
    dlg.DoModal();
	return TDX_SUCCESS;
}


DWORD 
APIENTRY 
OnAddComponent(
	LONG lConfigID,					// id of the active config
	LPCWSTR szCapabilityName,		// address of name of selected capability
	LPCWSTR szComponentName,		// address of name of selected component
	UINT nAppNum					// index of the activated tdx
	)
/*++
Function Description:
	Performs the operations needed when the component is added to the configuration.

Return code:
	TDX_SUCCESS - the applet was run successfully
	TDX_FAILED - the applet was not run successfully and did not notify the use
	TDX_FAILED_NONOTIFY - the applet was not run successfully and did notify the use
--*/
{
	UNREFERENCED_PARAMETER(szCapabilityName);
    UNREFERENCED_PARAMETER(szComponentName);
    UNREFERENCED_PARAMETER(nAppNum);

	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CTestRegInfo regInfo(lConfigID);

	AfxMessageBox(_T("Component is added"), MB_OK | MB_ICONINFORMATION);

	return TDX_SUCCESS;
}

DWORD 
APIENTRY 
OnRemoveComponent(
	LONG lConfigID,					// id of the active config
	LPCWSTR szCapabilityName,		// address of name of selected capability
	LPCWSTR szComponentName,		// address of name of selected component
	UINT nAppNum					// index of the activated tdx
	)
/*++
Function Description:
	Performs the operations needed when the component is removed from the configuration.
Return code:
	TDX_SUCCESS - the applet was run successfully
	TDX_FAILED - the applet was not run successfully and did not notify the use
	TDX_FAILED_NONOTIFY - the applet was not run successfully and did notify the use
--*/
{
	UNREFERENCED_PARAMETER(szCapabilityName);
    UNREFERENCED_PARAMETER(szComponentName);
    UNREFERENCED_PARAMETER(nAppNum);
	
	CTestRegInfo regInfo(lConfigID);
	AfxMessageBox(_T("Component is removed"));

	return TDX_SUCCESS;
}


DWORD  
APIENTRY 
OnPrebuildComponent(
	LONG lConfigID,					// id of the active config
	LPCWSTR szCapabilityName,		// address of name of selected capability
	LPCWSTR szComponentName,		// address of name of selected component
	UINT nAppNum					// index of the activated tdx
	)
/*++
Function Description:
	Performs the operations needed when the build of the configuration is performed.

Return code:
	TDX_SUCCESS - the applet was run successfully
	TDX_FAILED - the applet was not run successfully and did not notify the use
	TDX_FAILED_NONOTIFY - the applet was not run successfully and did notify the use
--*/
{
	UNREFERENCED_PARAMETER(lConfigID);
	UNREFERENCED_PARAMETER(szCapabilityName);
    UNREFERENCED_PARAMETER(szComponentName);
    UNREFERENCED_PARAMETER(nAppNum);
	
	return TDX_SUCCESS;
}

DWORD 
APIENTRY 
OnCheckDependencyComponent(
	LONG configID,					// id of the active config
	LPCWSTR szCapabilityName,		// address of name of selected capability
	LPCWSTR	szComponentName,		// address of name of selected component
	UINT nAppNum,					// index of the activated tdx
	LPBYTE lpDependency,			// address of data buffer to include MULTI_SZ list of depended components
	LPDWORD lpcbDependency,			// address of data buffer size
	LPBYTE lpConflict,				// address of data buffer to include MULTI_SZ list of conflicted components
	LPDWORD lpcbConflict			// address of data buffer size
	) 
/*++
Function Description:
	Gives the information of dinamic dependencies of the component

Return code:
	TDX_SUCCESS - the applet was run successfully
	TDX_FAILED - the applet was not run successfully and did not notify the use
	TDX_FAILED_NONOTIFY - the applet was not run successfully and did notify the use
--*/
{
	UNREFERENCED_PARAMETER(configID);
	UNREFERENCED_PARAMETER(szCapabilityName);
    UNREFERENCED_PARAMETER(szComponentName);
    UNREFERENCED_PARAMETER(nAppNum);
	UNREFERENCED_PARAMETER(lpDependency);
	UNREFERENCED_PARAMETER(lpcbDependency);
	UNREFERENCED_PARAMETER(lpConflict);
	UNREFERENCED_PARAMETER(lpcbConflict);
	
	return TDX_SUCCESS;
}

