// TestRegInfo.cpp: implementation of the CTestRegInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Test.h"
#include "TestRegInfo.h"
#include "tdxface.h"
#include "definitions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTestRegInfo::CTestRegInfo(LONG lConfigID)
{

	m_hTestKey = NULL;
	m_strTestValue = _T("");
	m_lConfigID = lConfigID;


}

CTestRegInfo::~CTestRegInfo()
{

	if (m_hTestKey != NULL)
		RapiCloseKey(m_hTestKey);


}

BOOL CTestRegInfo::GetTestValue(CString &strTestValue)
{
	//the key must be initialized already
	ASSERT(m_hTestKey != NULL);
	
	LONG lRet;
	DWORD dwSize = RAPI_MAX_DATA_SIZE;
	TCHAR buffer[RAPI_MAX_DATA_SIZE];

	lRet = RapiQueryValueEx(m_hTestKey,
        				    szTestValue, 
		        		    NULL,
				            NULL,
			                (LPBYTE) (LPCTSTR) buffer, 
				            &dwSize);

	if (ERROR_SUCCESS == lRet)
	{
		m_strTestValue = (LPCTSTR)buffer;
	}
	else
	{
		m_strTestValue = szDefaultTestValue;
	}

	strTestValue = m_strTestValue;
	return TRUE;

}

BOOL CTestRegInfo::SetTestValue(const CString &strTestValue)
{
	ASSERT(m_hTestKey != NULL);

	DWORD  dwSize = (strTestValue.GetLength() + 1) * sizeof(TCHAR);
	LONG lRet = RapiSetValueEx(m_hTestKey,
							   szTestValue,
							   NULL,
							   REG_SZ,
							   (LPBYTE)(LPCTSTR)strTestValue, 
							   dwSize);

	return (lRet == ERROR_SUCCESS);
}

BOOL CTestRegInfo::Initialize()
{
	HKEY hKey;
	LONG lRetVal = RapiOpenKeyEx(m_lConfigID,
								 HKEY_LOCAL_MACHINE,
						   	     szTestKey,
								 NULL,
								 KEY_ALL_ACCESS,
								 &hKey);

	if (lRetVal != ERROR_SUCCESS)
	{
		return FALSE;
	}

	m_hTestKey = hKey;	
	return TRUE;
}

//DEL BOOL CTestRegInfo::Intitialize2()
//DEL {
//DEL 
//DEL }
